#+-------------------------------------------------------------------
#  Makefile for u386mon for SCO UNIX V/386
#  ...!{gatech,emory}!n4hgf!wht
#--------------------------------------------------------------------
#+:EDITS:*/
#:08-10-1990-14:12-jmd@p1so/wht@n4hgf-2.20-add Tandem Integrity S2
#:08-07-1990-14:24-wht@n4hgf-nba@sysware.sysware.dk S5R31 updates
#:08-02-1990-15:35-wht@n4hgf-2.12-old curses hacks+minor 3.2 formalizations
#:08-01-1990-21:39-wht@n4hgf-add Dell make file
#:08-01-1990-12:26-wht@n4hgf-2.11-try to support ISC 1.x.x
#:07-28-1990-18:07-wht@n4hgf-2.10 release
#:07-26-1990-02:55-wht@n4hgf-add -nointl -- smaller + we don't use it
#:07-24-1990-18:53-wht@n4hgf-add USIZE_FIXED reminder
#:07-21-1990-16:03-wht@n4hgf-add libpanel + remake depend
#:06-30-1990-19:06-wht@n4hgf-run nlsym using full pathname
#:06-27-1990-01:57-wht@n4hgf-1.10 - incorporate suggestions from alpha testers
#:06-25-1990-04:14-wht@n4hgf-1.03-better error handling
#:06-21-1990-14:27-r@n4hgf-version x0.12 seems bug free
#:06-19-1990-21:37-wht@n4hgf-get ready for 0.08 release

#------------> CFLAGS 
# Add -DVPIX if you have VP/ix
# Add -DMERGE386 if you have Merge/386
# Add -DUSIZE_FIXED if you get erroneous process sizes
CFLAGS = -c -nointl -Octl -CSON -DLINT_ARGS

#------------> LIB
LIB = -lpanel -ltinfo -lx -lmalloc -lc_s

#------------> KMEMGRP
KMEMGRP = mem

#------------> BINDIR
BINDIR = /usr/local/bin

LDFLAGS = -s -nointl

VERSION = 2.20

#handle Sys V make "feature" of using SHELL
SHELL = /bin/sh

#FCRC = fcrc -u $*.c ;
FCRC = @echo ignore redefinition warnings for box and newterm;
.c.o:;	$(FCRC) $(CC) $(CFLAGS) $*.c 

SRC = \
	u386mon.c\
	bootinfo.c\
	detail.c\
	det_proc.c\
	det_sio.c\
	disputil.c\
	kludge.c\
	libkmem.c\
	libmem.c\
	libpanel.c\
	libswap.c\
	libnlsym.c\
	nlsym.c\
	proc.c\
	tune.c\
	var.c

HDR = \
	config.h\
	libkmem.h\
	libmem.h\
	libpanel.h\
	libswap.h\
	libnlsym.h\
	lint_args.h\
	nlsym.h\
	u386mon.h

NLSYM_OBJ =\
	nlsym.o

U386MON_OBJ =\
	u386mon.o\
	detail.o\
	det_proc.o\
	det_sio.o\
	bootinfo.o\
	kludge.o\
	proc.o\
	tune.o\
	var.o\
	disputil.o\
	libkmem.o\
	libmem.o\
	libswap.o\
	libnlsym.o

SHARFLS = \
	README\
	EXPLAIN\
	Makefile.sco\
	Makefile.isc1\
	Makefile.isc2\
	Makefile.dell\
	Makefile.s2\
	Makefile.sVr31\
	$(SRC)\
	$(HDR)\
	renice/Makefile\
	renice/renice.c\
	panel/README\
	panel/panel.3\
	panel/ptest.c\
	panel/Makefile

all: nlsym u386mon

#must run as root
install: all
	cp nlsym $(BINDIR)
	chown bin $(BINDIR)/nlsym
	chgrp bin $(BINDIR)/nlsym
	chmod 711 $(BINDIR)/nlsym
	mv u386mon $(BINDIR)
	chown bin $(BINDIR)/u386mon
	chgrp $(KMEMGRP) $(BINDIR)/u386mon
	chmod 2711 $(BINDIR)/u386mon
	$(BINDIR)/nlsym
	@echo ' ';echo 'csh users rehash before executing'

nlsym: $(NLSYM_OBJ)
	$(CC) $(LDFLAGS) -o $@ $(NLSYM_OBJ) $(LIB)

u386mon: $(U386MON_OBJ)
	$(CC) $(LDFLAGS) -o $@ $(U386MON_OBJ) $(LIB)

/unix.nlsym: nlsym /unix
	$(BINDIR)/nlsym
	chmod 644 /unix.nlsym

#not delivered
src.fls: $(SRC) Makefile
	ls $(SRC) > src.fls
lint_args: src.fls
	echo ' ' > lint_args.h
	csh zgcc src.fls lint_args.h $(CFLAGS)

clean:
	rm -f $(U386MON_OBJ) $(NLSYM_OBJ) \
		core u386mon.lint Makefile.bak src.fls mkdep.* cscope.out tags a.out

clobber: clean
	rm -f nlsym u386mon

lint:
	lint -ux *.c > u386mon.lint

#for shar 3.27 or later
shar:
	shar -a -n u386mon.$(VERSION) -l 55 -o $(VERSION).sh $(SHARFLS)

# MAKE DEPEND: regenerate .c:.h, .ol:.c, .ol:.asm dependencies automatically
#
depend:
		rm -f mkdep.rule.tmp
		if test '$(SRC)' ;\
		then (grep '^#include' $(SRC) \
		| sed	-e 's?:[^<]*<\([^>]*\)>.*?: /usr/include/\1?'\
			-e 's?:[^"]*"\([^"]*\)".*?: \1?'\
			-e 's?\(.*\)\.c?\1.o?'\
		 >> mkdep.rule.tmp) ;\
		fi

		echo 1 >mkdep.ex.tmp
		echo '/^# DO NOT DELETE THIS LINE' >>mkdep.ex.tmp
		echo '.+1,$$d' >>mkdep.ex.tmp
		echo 'r mkdep.rule.tmp' >> mkdep.ex.tmp
		echo 'w' >> mkdep.ex.tmp
		cp Makefile.sco Makefile.new
		ex Makefile.new < mkdep.ex.tmp
		rm mkdep.ex.tmp mkdep.rule.tmp
		echo '#	DEPENDENCIES MUST END AT END OF	FILE' >>Makefile.new
		echo '#	IF YOU PUT STUFF HERE IT WILL GO AWAY'>>Makefile.new
		echo '#	see make depend	above'>>Makefile.new
		mv Makefile.sco Makefile.bak
		mv Makefile.new Makefile.sco

# DO NOT DELETE THIS LINE
u386mon.o: config.h
u386mon.o: /usr/include/curses.h
u386mon.o: libpanel.h
u386mon.o: /usr/include/signal.h
u386mon.o: /usr/include/string.h
u386mon.o: /usr/include/fcntl.h
u386mon.o: /usr/include/nlist.h
u386mon.o: /usr/include/errno.h
u386mon.o: /usr/include/time.h
u386mon.o: /usr/include/sys/types.h
u386mon.o: /usr/include/sys/lock.h
u386mon.o: /usr/include/sys/utsname.h
u386mon.o: /usr/include/sys/stat.h
u386mon.o: /usr/include/sys/param.h
u386mon.o: /usr/include/sys/tuneable.h
u386mon.o: /usr/include/sys/sysinfo.h
u386mon.o: /usr/include/sys/sysmacros.h
u386mon.o: /usr/include/sys/immu.h
u386mon.o: /usr/include/sys/region.h
u386mon.o: /usr/include/sys/proc.h
u386mon.o: /usr/include/sys/var.h
u386mon.o: /usr/include/sys/swap.h
u386mon.o: /usr/include/sys/trap.h
u386mon.o: nlsym.h
u386mon.o: libkmem.h
u386mon.o: libmem.h
u386mon.o: libswap.h
u386mon.o: libnlsym.h
u386mon.o: u386mon.h
bootinfo.o: config.h
bootinfo.o: /usr/include/curses.h
bootinfo.o: /usr/include/sys/types.h
bootinfo.o: /usr/include/sys/bootinfo.h
bootinfo.o: u386mon.h
detail.o: config.h
detail.o: /usr/include/curses.h
detail.o: /usr/include/signal.h
detail.o: /usr/include/string.h
detail.o: /usr/include/fcntl.h
detail.o: /usr/include/nlist.h
detail.o: /usr/include/errno.h
detail.o: /usr/include/time.h
detail.o: /usr/include/pwd.h
detail.o: /usr/include/sys/types.h
detail.o: /usr/include/utmp.h
detail.o: /usr/include/sys/utsname.h
detail.o: /usr/include/sys/stat.h
detail.o: /usr/include/sys/param.h
detail.o: /usr/include/sys/tuneable.h
detail.o: /usr/include/sys/sysinfo.h
detail.o: /usr/include/sys/sysmacros.h
detail.o: /usr/include/sys/immu.h
detail.o: /usr/include/sys/region.h
detail.o: /usr/include/sys/proc.h
detail.o: /usr/include/sys/var.h
detail.o: nlsym.h
detail.o: libkmem.h
detail.o: libnlsym.h
detail.o: u386mon.h
det_proc.o: config.h
det_proc.o: /usr/include/curses.h
det_proc.o: /usr/include/signal.h
det_proc.o: /usr/include/string.h
det_proc.o: /usr/include/fcntl.h
det_proc.o: /usr/include/nlist.h
det_proc.o: /usr/include/errno.h
det_proc.o: /usr/include/time.h
det_proc.o: /usr/include/pwd.h
det_proc.o: /usr/include/sys/types.h
det_proc.o: /usr/include/utmp.h
det_proc.o: /usr/include/sys/stat.h
det_proc.o: /usr/include/sys/param.h
det_proc.o: /usr/include/sys/tuneable.h
det_proc.o: /usr/include/sys/sysinfo.h
det_proc.o: /usr/include/sys/sysmacros.h
det_proc.o: /usr/include/sys/immu.h
det_proc.o: /usr/include/sys/region.h
det_proc.o: /usr/include/sys/proc.h
det_proc.o: /usr/include/sys/fs/s5dir.h
det_proc.o: /usr/include/sys/user.h
det_proc.o: /usr/include/sys/var.h
det_proc.o: nlsym.h
det_proc.o: libkmem.h
det_proc.o: libmem.h
det_proc.o: libswap.h
det_proc.o: libnlsym.h
det_proc.o: u386mon.h
det_sio.o: config.h
det_sio.o: /usr/include/curses.h
det_sio.o: /usr/include/string.h
det_sio.o: /usr/include/nlist.h
det_sio.o: /usr/include/sys/types.h
det_sio.o: /usr/include/sys/stat.h
det_sio.o: /usr/include/sys/ascii.h
det_sio.o: /usr/include/sys/param.h
det_sio.o: /usr/include/sys/tty.h
det_sio.o: nlsym.h
det_sio.o: libkmem.h
det_sio.o: libmem.h
det_sio.o: libswap.h
det_sio.o: libnlsym.h
det_sio.o: u386mon.h
disputil.o: config.h
disputil.o: /usr/include/curses.h
disputil.o: /usr/include/sys/types.h
disputil.o: u386mon.h
kludge.o: /usr/include/curses.h
libkmem.o: /usr/include/sys/types.h
libkmem.o: /usr/include/fcntl.h
libkmem.o: libkmem.h
libmem.o: /usr/include/sys/types.h
libmem.o: /usr/include/fcntl.h
libmem.o: libmem.h
libpanel.o: config.h
libpanel.o: /usr/include/curses.h
libpanel.o: u386mon.h
libswap.o: /usr/include/sys/types.h
libswap.o: /usr/include/fcntl.h
libswap.o: libswap.h
libnlsym.o: config.h
libnlsym.o: /usr/include/stdio.h
libnlsym.o: /usr/include/sys/types.h
libnlsym.o: /usr/include/sys/stat.h
libnlsym.o: /usr/include/fcntl.h
libnlsym.o: /usr/include/nlist.h
libnlsym.o: nlsym.h
libnlsym.o: libnlsym.h
nlsym.o: config.h
nlsym.o: /usr/include/stdio.h
nlsym.o: /usr/include/sys/types.h
nlsym.o: /usr/include/sys/stat.h
nlsym.o: /usr/include/fcntl.h
nlsym.o: /usr/include/nlist.h
nlsym.o: nlsym.h
proc.o: config.h
proc.o: /usr/include/curses.h
proc.o: /usr/include/sys/types.h
proc.o: /usr/include/sys/param.h
proc.o: /usr/include/sys/immu.h
proc.o: /usr/include/sys/region.h
proc.o: /usr/include/sys/proc.h
proc.o: /usr/include/sys/var.h
proc.o: /usr/include/nlist.h
proc.o: nlsym.h
proc.o: libkmem.h
proc.o: libnlsym.h
proc.o: u386mon.h
tune.o: config.h
tune.o: /usr/include/curses.h
tune.o: /usr/include/sys/types.h
tune.o: /usr/include/sys/tuneable.h
tune.o: u386mon.h
var.o: config.h
var.o: /usr/include/curses.h
var.o: /usr/include/sys/types.h
var.o: /usr/include/sys/var.h
var.o: u386mon.h
#	DEPENDENCIES MUST END AT END OF	FILE
#	IF YOU PUT STUFF HERE IT WILL GO AWAY
#	see make depend	above
